package BaseDatos;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import javax.swing.JOptionPane;


public class ManejadorDB {
        ConexionMySQL mysql;  
        Connection conexion;
        String sSQL     =   "";
        
        public ManejadorDB(){
            
        this.mysql = new ConexionMySQL();
        this.conexion    = mysql.Conectar();
           
        }
       
    /* Elimina un registro que contenga el nombre_borrar*/     
  public synchronized void Eliminar (String Borrar,String Tabla,String Columna){ 
        sSQL="DELETE FROM "+Tabla+" WHERE "+Columna+" = '" + Borrar+"'";
        String correcto="Se ha borrado registro de con nombre "+Borrar+" .";
                        
         try
         {                            
              PreparedStatement pst = conexion.prepareStatement(sSQL);
                   
              if(pst.executeUpdate()>0){
                        JOptionPane.showMessageDialog(null, correcto);
              }
                    
          }
          catch (SQLException ex) 
          {
                        JOptionPane.showMessageDialog(null,ex);
          }
         
    }
    
    /*Edita registro, cambia el nombres */
  public synchronized void Editar(String A_Editar, String Nuevo, String Tabla, String Columna){
        sSQL="UPDATE "+Tabla+" SET "+Columna+" = '"+Nuevo+"' WHERE Nombre_Prueba = '"+A_Editar+"'";
        String correcto="Se ha cambiado "+A_Editar+" a "+Nuevo+" .";      
        
         try
         { 
              PreparedStatement pst = conexion.prepareStatement(sSQL);
                   
              if(pst.executeUpdate()>0){
                        JOptionPane.showMessageDialog(null, correcto);
              }
                    
          }
          catch (SQLException ex) 
          {
              JOptionPane.showMessageDialog(null,ex);
          }
        
    }
           
    /* Agrega un registro a una tabla */
  public synchronized String Agregar (String[] MensajeDB,String Tabla){
      String respuesta;
     
     if(Tabla.equals("Usuarios"))
     {
     sSQL="INSERT INTO "+Tabla+" (Mail_Usuario,Pass_Usuario,PriN_Usuario,SegN_Usuario,"
             + "PriA_Usuario,SegA_Usuario,Rut_Usuario,FN_Usuario,FR_Usuario,Gen_Usuario)"
             + " VALUES(?,?,?,?,?,?,?,?,?,?)";
     }
     else if(Tabla.equals("Denuncias"))
     {
     sSQL="INSERT INTO "+Tabla+" (Usuario_Denuncia,NChofer_Denuncia,AChofer_Denuncia,Patente_Denuncia,"
             + "Linea_Denuncia,Fecha_Denuncia,Hora_Denuncia,Empresa_Denuncia,Denuncia,Comentario_Denuncia) "
             + " VALUES(?,?,?,?,?,?,?,?,?,?)";
     }
     else 
     {
     sSQL="INSERT INTO "+Tabla+" (PriN_Chofer,SegN_Chofer,PriA_Chofer,SegA_Chofer,Rut_Chofer,"
             + "FNac_Chofer,FDesp_Chofer,Linea_Chofer,Servi_Chofer) "
             + "VALUES(?,?,?,?,?,?,?,?,?,?)";
     }
     
     String correcto="Se han guardado los datos en "+ Tabla+" ."; 
     
     String[] T = Tabla.split("_"); 
            
           try
           {
           PreparedStatement pst = conexion.prepareStatement(sSQL);
           pst.setString(1, MensajeDB[2]);
           pst.setString(2, MensajeDB[3]);
           pst.setString(3, MensajeDB[4]);
           pst.setString(4, MensajeDB[5]);
           pst.setString(6, MensajeDB[7]);
           pst.setString(7, MensajeDB[8]);
           pst.setString(8, MensajeDB[9]);
           pst.setString(9, MensajeDB[10]);            
           pst.setString(10,MensajeDB[11]);           
           if (Tabla.equals("Usuarios")) 
           {
                pst.setString(5, MensajeDB[6]);
  //              pst.setString(10,MensajeDB[11]);
           }
           else if( Tabla.equals("Denuncias")) 
           {
               pst.setInt(5, Integer.parseInt(MensajeDB[6]));
           }
           

                if(pst.executeUpdate()>0)
                {
                System.out.println(correcto);
                }
                
                respuesta ="Información guardada correctamente!";
           }
           catch (SQLException ex)
           {
                System.out.println(ex);
                respuesta= "No se podido guardar la información!";
           }
           
           
     //      if(Tabla.equals("Usuarios")) respuesta= MensajeDB[2]+" registrado correctamente!";
     //      else respuesta = "Datos agregados correctamente a " + Tabla;
         //  System.out.println("Agregados correctamente!");
           return respuesta;
        
    }
    
    /* Verifica si Usuario y Contraseña son correctas */
  public synchronized int Acceso_Usuario(String Tabla,String Usuario,String Contraseña){
        int encontrado  = 0;
        Statement sentencia;
        ResultSet resultado = null;
        sSQL="SELECT * FROM "+Tabla+" WHERE (Mail_Usuario = '"+Usuario+"'"
                + " AND Pass_Usuario = '"+Contraseña+"')";
        try{
         sentencia  = conexion.createStatement();
         resultado  = sentencia.executeQuery(sSQL);

         while (resultado.next())
         encontrado = resultado.getInt("ID_Usuario");

        }
        catch (SQLException ex)
        {
       JOptionPane.showMessageDialog(null,ex);
        }
        
        return encontrado; /* Si es mayor a cero, es por que lo encontró */
    }
    
    /* Consulta informacion de registro de una tabla */
  public synchronized ResultSet Consulta_Registro(String Tabla,String Dato,String Dato_Consultado){
        Statement sentencia;
        ResultSet resultado = null;
        ResultSet respuesta = null;
        
        if(Dato_Consultado.equals("= 'HOLA'")) Dato_Consultado= ">0";
        sSQL="SELECT * FROM "+Tabla+" WHERE "+Dato+ Dato_Consultado;
                System.out.println("LO QUE SE BUSCA! = "+sSQL);
        try{
         sentencia  = conexion.createStatement();
         System.out.println("AS");
         resultado  = sentencia.executeQuery(sSQL);
                   System.out.println("DF");
         
    //   while (resultado.next())
      //  JOptionPane.showMessageDialog(null,resultado.getInt(1)+" "+resultado.getString(2)+" "+resultado.getString(3));
        
        }
        catch (SQLException ex)
        { System.out.println("AS");
       JOptionPane.showMessageDialog(null,ex);
          System.out.println("DF");
        }
        

        
        return resultado;
    }
    
    /* Crea tabla de una Empresa */
  public synchronized void Crear_Tabla(String Tabla){
        
        sSQL ="CREATE TABLE "+Tabla+" (ID_Chofer INT NOT NULL AUTO_INCREMENT," +
                                       "PriN_Chofer VARCHAR(50) NOT NULL,"+
                                       "SegN_Chofer VARCHAR(50) NOT NULL,"+
                                       "PriA_Chofer VARCHAR(50) NOT NULL,"+
                                       "SegA_Chofer VARCHAR(50) NOT NULL,"+
                                       "Rut_Chofer INT(11),"+
                                       "FNac_Chofer DATE,"+
                                       "FCont_Chofer DATE,"+
                                       "FDesp_Chofer DATE,"+
                                       "Linea_Chofer INT(11),"+
                                       "Servi_Chofer VARCHAR(2) NOT NULL,"+
                                       "Foto_Chofer BLOB NULL,"+
                                       "PRIMARY KEY ( ID_Chofer ))";
        
        try{
        Statement sentencia = conexion.createStatement();
        sentencia.executeUpdate(sSQL);
        }
        catch (SQLException e)
        {
            JOptionPane.showMessageDialog(null,"Ya está Creada!");
        }
        
    }
  
  
       
    
}
